import React, { useMemo } from 'react';
import { StyleSheet, View } from 'react-native';
import { SvgXml } from 'react-native-svg';

import { Colors } from '@growth/commons/utils';


const BrandIcon = ({ color = Colors.PRIMARY, size = 94, style, ...otherProps }) => {
  const containerStyle = useMemo(() => ({ width: size, height: size, ...style }), [size, style]);

  return (
    <View style={containerStyle} { ...otherProps }>
      <SvgXml width="100%" height="100%" xml={`
        <svg width="28" height="32" viewBox="0 0 28 32">
          <path
            fill="${color}"
            d="M27.716 0l-0.004 0.245c-0.073 4.146-1.018 7.157-2.892 8.966-2.251 2.172-5.127 2.92-8.569 2.116l-2.329 2.316v8.402l2.774-2.714c-0.769-0.982-0.712-2.39 0.192-3.242 0.96-0.904 2.49-0.817 3.415 0.165s0.921 2.515-0.039 3.419c-0.902 0.849-2.307 0.824-3.241 0.003l-3.1 3.033v9.203h-0.475v-3.506l-3.166-3.262c-1.527 0.365-2.91 0.376-4.168 0.042-1.295-0.343-2.444-1.047-3.472-2.078-1.702-1.707-2.562-4.54-2.636-8.435l-0.005-0.246 0.247 0.005c3.922 0.075 6.775 0.946 8.494 2.67 2.059 2.066 2.606 4.708 1.878 7.709l2.828 2.914v-14.084l-4.237-4.345c-1.095 0.859-2.69 0.745-3.66-0.295-1.025-1.098-0.972-2.817 0.122-3.838s2.813-0.954 3.837 0.144c0.968 1.038 0.974 2.631 0.048 3.664l4.13 4.236 2.226-2.214c-0.814-3.205-0.082-5.991 2.183-8.176 1.892-1.825 5.037-2.744 9.374-2.814l0.245-0.004zM16.668 10.934c3.163 0.657 5.766-0.080 7.822-2.064 1.706-1.646 2.637-4.421 2.742-8.386-4.163 0.099-7.078 1.009-8.805 2.676-2.072 1.999-2.787 4.517-2.116 7.458l4.67-4.353 0.324 0.347-4.637 4.322zM9.161 5.631c-0.848-0.908-2.266-0.96-3.166-0.121s-0.946 2.259-0.098 3.167c0.847 0.908 2.266 0.96 3.166 0.12s0.946-2.258 0.098-3.167z"
          />
        </svg>
      `}/>
    </View>
  );
};

const BrandText = ({ color = Colors.PRIMARY, size = 94, style, ...otherProps }) => {
  const containerStyle = useMemo(() => ({ width: size, height: size, ...style }), [size, style]);

  return (
    <View style={containerStyle} { ...otherProps }>
      <SvgXml width="100%" height="100%" xml={`
        <svg width="91" height="32" viewBox="0 0 91 32">
          <path
            fill="${color}"
            d="M7.492 32c-2.201 0-3.984-0.402-5.349-1.206s-2.047-1.947-2.047-3.428c0-1.63 0.899-2.846 2.698-3.65-1.016-0.508-1.523-1.164-1.523-1.968 0-1.016 0.614-1.767 1.841-2.253-0.868-0.529-1.535-1.249-2-2.159s-0.699-1.936-0.699-3.078c0-1.143 0.259-2.175 0.777-3.095s1.259-1.645 2.222-2.174c0.963-0.529 2.101-0.794 3.413-0.794 1.396 0 2.666 0.402 3.809 1.206 1.121-0.635 2.412-0.952 3.872-0.952h0.255l-0.35 1.905h-0.73c-0.191 0-0.466 0.021-0.825 0.064s-0.677 0.095-0.952 0.159c0.444 0.508 0.782 1.080 1.015 1.715s0.35 1.291 0.35 1.968c0 1.185-0.259 2.248-0.778 3.189s-1.264 1.683-2.237 2.222c-0.974 0.54-2.117 0.81-3.428 0.81-0.762 0-1.461-0.095-2.096-0.286-0.487 0.17-0.73 0.445-0.73 0.826 0 0.507 0.582 0.846 1.746 1.016l4.158 0.666c1.735 0.275 3.048 0.772 3.936 1.492s1.333 1.713 1.333 2.983c0 1.587-0.683 2.788-2.048 3.603s-3.243 1.222-5.634 1.222zM6.826 18.192c1.185 0 2.1-0.355 2.746-1.063s0.967-1.656 0.967-2.841c0-1.143-0.322-2.064-0.967-2.762s-1.561-1.047-2.746-1.047c-1.185 0-2.096 0.349-2.731 1.047s-0.952 1.619-0.952 2.762c0 1.185 0.317 2.132 0.952 2.841s1.545 1.063 2.731 1.063zM7.746 29.461c1.46 0 2.582-0.19 3.365-0.571s1.174-0.931 1.174-1.651c0-0.55-0.238-0.989-0.714-1.317s-1.191-0.587-2.143-0.777l-4.444-0.762c-0.635 0.297-1.153 0.662-1.555 1.096s-0.604 0.914-0.604 1.444c0 0.868 0.434 1.508 1.302 1.921s2.073 0.619 3.618 0.619zM17.015 24.064v-15.554h2.349l0.349 2.572c0.804-0.995 1.571-1.725 2.301-2.191s1.498-0.699 2.302-0.699c0.254 0 0.497 0.032 0.73 0.095l-0.285 3.143c-0.276-0.063-0.593-0.095-0.952-0.095-0.783 0-1.524 0.175-2.222 0.524s-1.207 0.756-1.524 1.222v10.982h-3.047zM33.426 24.382c-1.587 0-2.963-0.355-4.127-1.064s-2.053-1.677-2.667-2.904c-0.613-1.227-0.92-2.603-0.92-4.127s0.307-2.899 0.92-4.127c0.614-1.227 1.503-2.195 2.667-2.904s2.539-1.063 4.127-1.063c1.565 0 2.936 0.354 4.11 1.063s2.069 1.677 2.682 2.904c0.614 1.227 0.921 2.603 0.921 4.127s-0.307 2.899-0.921 4.127c-0.613 1.227-1.507 2.195-2.682 2.904s-2.545 1.064-4.11 1.064zM33.426 21.842c1.524 0 2.703-0.487 3.539-1.46s1.253-2.339 1.253-4.095-0.418-3.121-1.253-4.094c-0.836-0.974-2.016-1.461-3.539-1.461s-2.704 0.487-3.539 1.461c-0.836 0.973-1.255 2.338-1.255 4.094s0.418 3.121 1.255 4.095c0.836 0.973 2.015 1.46 3.539 1.46zM47.043 24.064l-4.665-15.554h3.364l2.984 12.412 3.301-11.936h2.952l3.333 11.936 2.984-12.412h3.364l-4.698 15.554h-3.205l-3.238-11.491-3.269 11.491h-3.207zM72.31 24.382c-1.376 0-2.396-0.36-3.063-1.079s-1-1.598-1-2.635v-9.935h-2.667l0.253-2.222h2.413v-3.84l2.857-0.286v4.127h4.094v2.222h-4.094v8.189c0 1.080 0.063 1.82 0.19 2.222s0.396 0.662 0.81 0.778c0.412 0.116 1.169 0.174 2.269 0.174h0.73l-0.222 2.286h-2.571zM85.071 8.193c1.968 0 3.47 0.646 4.507 1.937s1.556 3.047 1.556 5.269v8.665h-2.857v-8.317c0-1.714-0.312-2.978-0.936-3.793s-1.593-1.222-2.904-1.222c-0.805 0-1.545 0.185-2.222 0.556s-1.249 0.894-1.715 1.571v11.205h-2.888v-23.807h2.888v9.745c0.614-0.592 1.286-1.042 2.016-1.348s1.581-0.461 2.556-0.461z"
          />
        </svg>
      `}/>
    </View>
  );
};

const BrandHeader = ({ style, ...otherProps }) => {
  const containerStyle = useMemo(() => ({ ...styles.brandContainer, ...style }), [style]);

  return (
    <View style={containerStyle} { ...otherProps }>
      <View style={styles.brandBackground} />
      <BrandIcon color={Colors.WHITE}/>
      <BrandText color={Colors.WHITE} style={styles.brandText}/>
    </View>
  );
};

const styles = StyleSheet.create({
  brandContainer: {
    alignItems: 'center',
    overflow: 'hidden',
    paddingBottom: 24,
  },

  brandBackground: {
    backgroundColor: Colors.PRIMARY,
    position: 'absolute',
    bottom: 0,
    width: '130%',
    height: '290%',
    borderRadius: 9999,
  },

  brandText: {
    marginTop: -24,
  },
});

export {
  BrandIcon,
  BrandText,
  BrandHeader
};